@echo off
rem *********************************************************************
rem *                                                                   *
rem * NOME SCRIPT: RestartService.cmd                                   *
rem *                                                                   *
rem * Script scritto da Alessandro Tani (Home Works S.p.A.)             *
rem *                                                                   *
rem * Versione 1.0 - Modificato l'ultima volta il 25/01/2010            *
rem *                da Alessandro Tani                                 *
rem * SCOPO:                                                            *
rem *                                                                   *
rem *  Questo script ha il compito di riavviare un servizio ed          *
rem *  i servizi che dipendono dal servizio che si vuole fermare        *
rem *                                                                   *
rem * File di log: %SystemDrive%\Logs\RestartService.log                *
rem *                                                                   *
rem * PREREQUISITI:                                                     *
rem *                                                                   *
rem * Lo script utilizza il file ..\Vbs\RestartService.vbs              *
rem * Lo script pu essere eseguito solamente sulle macchine            *
rem * con sistema operativo Windows 2000 o superiore                    *
rem *                                                                   *
rem * TESTO:                                                            *
rem *                                                                   *
rem *  Nessuno                                                          *
rem *                                                                   *
rem *********************************************************************

rem Definiamo l'ambiente locale
setlocal enableextensions

rem Impostiamo le variabili
if "%1" equ "" goto HELP

rem Controlliamo gli altri dati inseriti dall'utente
if "%2" neq "" goto TEST
if "%3" neq "" goto HELP

rem Controlliamo la presenza degli script necessari all'esecuzione
if not exist %SystemDrive%\Bin\Vbs\RestartService.vbs goto NOSCRIPTS

:CONTINUE
cscript //nologo %SystemDrive%\Bin\Vbs\RestartService.vbs %1 %2 %COMPUTERNAME%
goto END

:TEST
if /i "%2" equ "-r" goto CONTINUE
if /i "%2" equ "-s" goto CONTINUE
echo.
echo La sintassi del comando RestartService non e' corretta!
goto HELP

:HELP
echo.
echo Questo script ha il compito di riavviare un servizio
echo ed i servizi che dipendono dal servizio da riavviare.
echo Lo script puo' essere eseguito solamente sulle macchine che
echo hanno come sistema operativo Windows 2000 od uno superiore.
echo Per la sua esecuzione lo script utilizza il file
echo %SystemDrive%\Bin\Vbs\RestartService.vbs che pertanto deve esistere.
echo.
echo Sintassi:
echo.
echo   RestartService ^<NomeServizio^> [Opzioni]
echo.
echo Dove:
echo.
echo  ^<NomeServizio^>: indica il servizio da riavviare. Per conoscere i nomi dei
echo                  dei servizi da riavviare utilizzare il comando "ListServices".
echo.
echo  [Opzioni]: indica le opzioni disponibili:
echo.
echo     *  L'opzione "-r" sta ad indicare che lo script viene esegiuto in modalita'
echo        interattiva con l'utente: vengono riporati i dettagli di ciascuna operazione.
echo.
echo     *  L'opzione "-s" sta ad indicare che lo script viene eseguito
echo        in modalita' silente (Default).
echo.
echo Per i dettagli sull'esecuzione dello script si puo' consultare
echo il file di log %SystemDrive%\Logs\RestartService.log
echo.
echo Esempi:
echo.
echo   Per riavviare il servizio "Smart Card" in modalita' interattiva:
echo.
echo      RestartService SCardSvr -r
echo.
echo   Per riavviare il servizio "Smart Card" in modalita' silente:
echo.
echo      RestartService SCardSvr -s
echo      RestartService SCardSvr
echo.
goto END

:NOSCRIPTS
echo Il file %SystemDrive%\Bin\Vbs\RestartServices.vbs non esiste. 
echo Pertanto non e' possibile proseguire nell'esecuzione dello script. 
echo Controlla che il file esista.
echo.
goto HELP

:END
endlocal
exit /b