' *********************************************************************
' *                                                                   *
' * NOME SCRIPT: RestartService.vbs                                   *
' *                                                                   *
' * Script scritto da A. Tani (Home Works S.p.A.)                     *
' *                                                                   *
' * Versione 1.0 - Modificato l'ultima volta il 25/01/2010            *
' *                da Alessandro Tani                                 *
' * SCOPO:                                                            *
' *                                                                   *
' *  Riavvia un servizio se  in esecuzione. Lo script si propone     *
' *  di fermare tutti i servizi da cui il servizio da fermare         *
' *  dipende e di riavviare tutti i servizi a cui il servizio dipende *
' *                                                                   *
' * File di log: %SystemDrive%\Logs\RetsartService.log                *
' *                                                                   *
' * PREREQUISITI:                                                     *
' *                                                                   *
' *  L'utente che esegue lo script deve avere diritti                 *
' *  sulla macchina.                                                  *
' *                                                                   *
' * TESTO:                                                            *
' *                                                                   *
' *  Nessuno                                                          *
' *                                                                   *
' *********************************************************************

'Dichiariamo sempre le variabili
Option Explicit

'Impostiamo gli oggetti
Dim objShell, objFSO, objWMI, objLogScript, objArgs, objEnv, objService, objDependecyService

'Impostiamo le variabili
Dim sSystemDrive, strLogScript, strService, strRunTime, bRunTime, strComputer, colServices, strComputerName
Dim strWMIQuery, colDependecyServiceList, iErrReturn, bDependecyService, bDependencyServiceStop
Dim bDependencyServiceStart

'Impostiamo il percorso del file di log dello script
Set objShell = CreateObject("WScript.Shell")
Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
Set objEnv = objShell.Environment("System")
sSystemDrive = objEnv("SystemDrive")
If not objFSO.FolderExists(sSystemDrive & "\Logs") then
   objFSO.CreateFolder(sSystemDrive & "\Logs")
End If
strLogScript = sSystemDrive & "\Logs\RestartService.log"
Set objLogScript = objFSO.CreateTextFile(strLogScript, True)
Set objArgs = WScript.Arguments

'Controlliamo gli argomenti
strService = objArgs(0) 'Nome del servizio da fermare
strRunTime = objArgs(1) 'Valutiamo se lo script  in modalit run time
strComputerName = objArgs(2) 'Nome del computer su cui eseguire il controllo

bRunTime = FALSE
If LCase(Trim(strRunTime)) = "-r" Then
   bRunTime = TRUE
   WScript.Echo ""
   WScript.Echo "Eseguiamo lo script in modalit run-time ..."
   WScript.Echo ""
End If


'Impostiamo il file di log dello script
objLogScript.WriteLine "+-------------------------------------------+"
objLogScript.WriteLine "|  File di log dello Script RestartService  |"
objLogScript.WriteLine "+-------------------------------------------+"
objLogScript.WriteLine ""
objLogScript.WriteLine "Esecuzione del " & Date() & " alle " & Time()
objLogScript.WriteLine ""

' Controlliamo se il servizio specificato  in esecuzione
Set objWMI = GetObject("winmgmts:{impersonationLevel=Impersonate}!\\" & strComputerName & "\root\cimv2")
Set objService = objWMI.Get("Win32_Service.Name='" & strService & "'")
objLogScript.WriteLine "Controlliamo lo stato di esecuzione del servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " sulla macchina " & Chr(34) & strComputerName & Chr(34) & " ..."
If bRunTime Then
   WScript.Echo "Controlliamo lo stato di esecuzione del servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" 
   WScript.Echo "sulla macchina " & Chr(34) & strComputerName & Chr(34) & " ..."
End If   
If objService.State = "Stopped" Then
   objLogScript.WriteLine ""
   objLogScript.WriteLine "  Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & "  gi fermo,"
   objLogScript.WriteLine "  pertanto non necessita di essere fermato."
   
   If bRunTime Then
      WScript.Echo ""
	  WScript.Echo "  Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & "  gi fermo,"
	  WScript.Echo "  pertanto non necessita di essere fermato."
   End If
   
Else 'Il Servizio specificato  in esecuzione

   objLogScript.WriteLine ""
   objLogScript.WriteLine "  Il servizio " & Chr(34) & objService.DisplayName & Chr(34) & "  in esecuzione!"
   objLogScript.WriteLine ""
   
   'Otteniamo l'elenco dei servizi da cui il Servizio specificato dipende
   strWMIQuery = "Associators of {Win32_Service.Name='" & strService &"'} Where AssocClass=Win32_DependentService " & "Role=Antecedent"
   Set colDependecyServiceList = objWMI.ExecQuery(strWMIQuery)

   'Fermiamo i Servizi da cui il Servizio specificato dipende
   objLogScript.WriteLine "Fermiamo i servizi che dipendono dal servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")."
   objLogScript.WriteLine ""

   If bRunTime Then
      WScript.Echo "Il servizio " & Chr(34) & objService.DisplayName & Chr(34) & "  in esecuzione!"
	  WScript.Echo ""
	  WScript.Echo "Fermiamo i servizi che dipendono dal servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")."
	  WScript.Echo ""
   End If
   
   bDependecyService = TRUE
   bDependencyServiceStop = TRUE
   For Each objDependecyService in colDependecyServiceList
       bDependecyService = FALSE
       objLogScript.WriteLine "  Fermiamo il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " (" & objDependecyService.Name & ")" & " ..."
	   iErrReturn = objDependecyService.StopService()
	   If iErrReturn = 0 Then
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " si  fermato regolarmente."
		  If bRunTime Then
		     WScript.Echo "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " si  fermato regolarmente."
			 WScript.Echo ""
		  End If
	   Else 'Uno dei Servizi da cui dipende il Servizio specificato non si  fermato
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " non si  fermato!" 
		  objLogScript.WriteLine "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
		  If bRunTime Then
		     WScript.Echo "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " non si  fermato!" 
			 WScript.Echo "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
			 WScript.Echo ""
		  End If
		  If iErrReturn <> 6 Then 'Se il servizio  gi fermo
		     bDependencyServiceStop = FALSE
		  End If
	   End If
	   objLogScript.WriteLine ""   
	Next

	If bDependecyService Then
	   objLogScript.WriteLine "Dal servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " non dipendono altri servizi."
	   If bRunTime Then
	      WScript.Echo "Dal servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " non dipendono altri servizi."
	   End If
	Else
       objLogScript.WriteLine "Tutti i servizi che dipendono dal servizio " & Chr(34) & objService.DisplayName & Chr(34) & " sono stati fermati."
	   If bRunTime Then
	      WScript.Echo "Tutti i servizi che dipendono dal servizio " & Chr(34) & objService.DisplayName & Chr(34) & " sono stati fermati."
       End If
	End If
	
	'Interrompiamo un attimo l'esecuzione dello script per consentire ai servizi di fermarsi
	Wscript.Sleep 20000
	
	'Fermiamo il servizio specificato
	objLogScript.WriteLine ""
	objLogScript.WriteLine "Fermiamo il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " ..."
	If bRunTime Then
	   WScript.Echo ""
	   WScript.Echo "Fermiamo il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " ..."
	End If
	If bDependencyServiceStop Then
	   iErrReturn = objService.StopService()
	   If iErrReturn = 0 Then
          objLogScript.WriteLine ""	   
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " si  fermato regolarmente."
		  If bRunTime Then
		     WScript.Echo "Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " si  fermato regolarmente."
		  End If
	   Else 'Il Servizio specificato non si  fermato regolarmente
	      objLogScript.WriteLine ""
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objService.DisplayName  & Chr(34)& " non si  fermato!" 
		  objLogScript.WriteLine "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
		  If bRunTime Then
		     WScript.Echo ""
			 WScript.Echo "  Il Servizio " & Chr(34) & objService.DisplayName  & Chr(34)& " non si  fermato!" 
			 WScript.Echo "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
		  End If
	   End If
	Else
	   objLogScript.WriteLine ""
	   objLogScript.WriteLine "  Poich non tutti i servizi che diepndono dal Servizio"
	   objLogScript.WriteLine "  " & Chr(34) & objService.DisplayName & Chr(34) & " si sono fermati, non risulta possibile"
	   objLogScript.WriteLine "  fermare il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")"
	   If bRunTime Then
	      WScript.Echo ""
		  WScript.Echo "  Poich non tutti i servizi che diepndono dal Servizio"
		  WScript.Echo "  " & Chr(34) & objService.DisplayName & Chr(34) & " si sono fermati, non risulta possibile"
		  WScript.Echo "  fermare il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")"
	   End If
	End If
	
End If

'Interrompiamo un attimo l'esecuzione dello script per consentire al servizio di fermarsi
If bRunTime Then
   WScript.Echo ""
   WScript.Echo "Fermiamo momentaneamente l'esecuzione dello script ..."
   WScript.Echo ""
End If 
Wscript.Sleep 20000

' Controlliamo se il servizio specificato  in esecuzione
Set objService = objWMI.Get("Win32_Service.Name='" & strService & "'")
objLogScript.WriteLine ""
objLogScript.WriteLine "Controlliamo lo stato di esecuzione del servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " ..."
If bRunTime Then
   WScript.Echo "Controlliamo lo stato di esecuzione del servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " ..."
End If   
If objService.State = "Running" Then
   objLogScript.WriteLine ""
   objLogScript.WriteLine "  Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & "  gi in esecuzione,"
   objLogScript.WriteLine "  pertanto non necessita di essere avviato."
   
   If bRunTime Then
      WScript.Echo ""
	  WScript.Echo "  Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & "  gi in esecuzione,"
	  WScript.Echo "  pertanto non necessita di essere avviato."
   End If
   
Else 'Il Servizio specificato non  in esecuzione

   objLogScript.WriteLine "Il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " non  in esecuzione!"
   objLogScript.WriteLine ""
   
   'Otteniamo l'elenco dei servizi da cui il Servizio specificato dipende
   strWMIQuery = "Associators of {Win32_Service.Name='" & strService &"'} Where AssocClass=Win32_DependentService " & "Role=Dependent"
   Set colDependecyServiceList = objWMI.ExecQuery(strWMIQuery)

   'Avviamo i Servizi da cui il Servizio specificato dipende
   objLogScript.WriteLine "Avviamo i servizi da cui il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " dipende ..."
   objLogScript.WriteLine ""

   If bRunTime Then
      WScript.Echo "Il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " non  in esecuzione!"
	  WScript.Echo ""
	  WScript.Echo "Avviamo i servizi da cui il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " dipende ..."
	  WScript.Echo ""
   End If
   
   bDependecyService = TRUE
   bDependencyServiceStart = TRUE
   For Each objDependecyService in colDependecyServiceList
       bDependecyService = FALSE
       objLogScript.WriteLine "  Avviamo il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " (" & objDependecyService.Name & ")" & " ..."
	   iErrReturn = objDependecyService.StartService()
	   If iErrReturn = 0 Then
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " si  avviato regolarmente."
		  If bRunTime Then
		     WScript.Echo "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " si  avviato regolarmente."
			 WScript.Echo ""
		  End If
	   Else 'Uno dei Servizi da cui dipende il Servizio specificato non si  avviato
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " non si  avviato!" 
		  objLogScript.WriteLine "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
		  If bRunTime Then
		     WScript.Echo "  Il Servizio " & Chr(34) & objDependecyService.DisplayName & Chr(34) & " non si  avviato!" 
			 WScript.Echo "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
			 WScript.Echo ""
		  End If
		  If iErrReturn <> 10 Then 'Se il servizio non  gi in esecuzione
		     bDependencyServiceStart = FALSE
		  End If
	   End If
	   objLogScript.WriteLine ""   
	Next

	If bDependecyService Then
	   objLogScript.WriteLine "Il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " non dipende da altri servizi"
	   If bRunTime Then
	      WScript.Echo "Il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " non dipende da altri servizi"
	   End If
	Else
       objLogScript.WriteLine "L'avvio di tutti i servizi da cui il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " dipende  terminato."
	   If bRunTime Then
	      WScript.Echo "L'avvio di tutti i servizi da cui il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " dipende  terminato."
       End If
	End If
	
	'Avviamo il servizio specificato
	objLogScript.WriteLine ""
	objLogScript.WriteLine "Avviamo il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " ..."
	If bRunTime Then
	   WScript.Echo ""
	   WScript.Echo "Avviamo il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")" & " ..."
	End If
	If bDependencyServiceStart Then
	   iErrReturn = objService.StartService()
	   If iErrReturn = 0 Then	     
	      objLogScript.WriteLine "Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " si  avviato regolarmente."
		  If bRunTime Then
		     WScript.Echo "Il Servizio " & Chr(34) & objService.DisplayName & Chr(34) & " si  avviato regolarmente."
		  End If
	   Else 'Il Servizio specificato non si  avviato regolarmente
	      objLogScript.WriteLine ""
	      objLogScript.WriteLine "  Il Servizio " & Chr(34) & objService.DisplayName  & Chr(34)& " non si  avviato!" 
		  objLogScript.WriteLine "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
		  If bRunTime Then
		     WScript.Echo ""
			 WScript.Echo "  Il Servizio " & Chr(34) & objService.DisplayName  & Chr(34)& " non si  avviato!" 
			 WScript.Echo "  Il Codice di Errore riportato : " & iErrReturn & " (" & DescrizioneErrore(iErrReturn) & ")"
		  End If
	   End If
	Else
	   objLogScript.WriteLine ""
	   objLogScript.WriteLine "  Poich non tutti i servizi da cui dipende il Servizio"
	   objLogScript.WriteLine "  " & Chr(34) & objService.DisplayName & Chr(34) & " si sono avviati, non risulta possibile"
	   objLogScript.WriteLine "  avviare il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")"
	   If bRunTime Then
	      WScript.Echo ""
		  WScript.Echo "  Poich non tutti i servizi da cui dipende il Servizio"
		  WScript.Echo "  " & Chr(34) & objService.DisplayName & Chr(34) & " si sono avviati, non risulta possibile"
		  WScript.Echo "  avviare il servizio " & Chr(34) & objService.DisplayName & Chr(34) & " (" & objService.Name & ")"
	   End If
	End If
	
End If

objLogScript.WriteLine ""
objLogScript.WriteLine "Terminata esecuzione alle " & Time()
objLogScript.WriteLine ""
objLogScript.WriteLine "Fine del file di log"
objLogScript.Close

'Funzioni

Function DescrizioneErrore(iErrorCode)

  'Descrizione degli errori relativi all'avvio di un servizio

  Select Case iErrorCode
  Case 1
        DescrizioneErrore = "Not Supported"
  Case 2
        DescrizioneErrore = "Access Denied"
  Case 3
        DescrizioneErrore = "Dependent Services Running"
  Case 4
        DescrizioneErrore = "Invalid Service Control"
  Case 5
        DescrizioneErrore = "Service Cannot Accept Control"
  Case 6
        DescrizioneErrore = "Service Not Active"
  Case 7
        DescrizioneErrore = "Service Request Timeout"
  Case 8
        DescrizioneErrore = "Unknown Failure"
  Case 9
        DescrizioneErrore = "Path Not Found"
  Case 10
        DescrizioneErrore = "Service Already Running"
  Case 11
        DescrizioneErrore = "Service Database Locked"
  Case 12
        DescrizioneErrore = "Service Dependency Deleted"
  Case 13
        DescrizioneErrore = "Service Dependency Failure"
  Case 14
        DescrizioneErrore = "Service Disabled"
  Case 15
        DescrizioneErrore = "Service Logon Failure"
  Case 16
        DescrizioneErrore = "Service Marked For Deletion"
  Case 17
        DescrizioneErrore = "Service No Thread"
  Case 18
        DescrizioneErrore = "Status Circular Dependency"
  Case 19
        DescrizioneErrore = "Status Duplicate Name"
  Case 20
        DescrizioneErrore = "Status Invalid Name"
  Case 21
        DescrizioneErrore = "Status Invalid Parameter"
  Case 22
        DescrizioneErrore = "Status Invalid Service Account"
  Case 23
        DescrizioneErrore = "Status Service Exists"
  Case 24
        DescrizioneErrore = "Service Already Paused"
  End Select
  
End Function